import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api/index';
import type { CmsMpAd, CmsMpAdParam } from './model';


/**
 * 分页查询小程序广告位
 */
export async function pageCmsMpAd(params: CmsMpAdParam) {
  const res = await request.get<ApiResult<PageResult<CmsMpAd>>>(
    '/cms/cms-mp-ad/page',
    {
      params
    }
  );
  if (res.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 查询小程序广告位列表
 */
export async function listCmsMpAd(params?: CmsMpAdParam) {
  const res = await request.get<ApiResult<CmsMpAd[]>>(
    '/cms/cms-mp-ad',
    {
      params
    }
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 添加小程序广告位
 */
export async function addCmsMpAd(data: CmsMpAd) {
  const res = await request.post<ApiResult<unknown>>(
    '/cms/cms-mp-ad',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 修改小程序广告位
 */
export async function updateCmsMpAd(data: CmsMpAd) {
  const res = await request.put<ApiResult<unknown>>(
    '/cms/cms-mp-ad',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 删除小程序广告位
 */
export async function removeCmsMpAd(id?: number) {
  const res = await request.del<ApiResult<unknown>>(
    '/cms/cms-mp-ad/' + id
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 批量删除小程序广告位
 */
export async function removeBatchCmsMpAd(data: (number | undefined)[]) {
  const res = await request.del<ApiResult<unknown>>(
    '/cms/cms-mp-ad/batch',
    {
      data
    }
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 根据id查询小程序广告位
 */
export async function getCmsMpAd(id: number) {
  const res = await request.get<ApiResult<CmsMpAd>>(
    '/cms/cms-mp-ad/' + id
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}
